--- Made by Sq
AUTOACTBAR_ON = "on"
AUTOACTBAR_OFF = "off"
AutoActBar_Loading = false
AutoActBar_SaveVar = { name, type }
AutoActBar_first = true

function AutoActBar_SaveSlot( lActionSlot )
	if ( lActionSlot >= 25 and lActionSlot <= 72) then
		local lConsumable = IsConsumableAction(lActionSlot);            -- type = 1     -   (,   .)
		local lEquipped = IsEquippedAction(lActionSlot);                -- type = 2    -    
		local lActionText = GetActionText(lActionSlot);                 -- type = 3    - Macros
		local lActionTexture = GetActionTexture(lActionSlot);           -- type = 4    -   

		if ( lConsumable == 1 ) then
			AAB_Tooltip:SetOwner(UIParent, "ANCHOR_NONE");
--			AAB_Tooltip:SetOwner(AAB_Tooltip, "ANCHOR_NONE");
			AAB_Tooltip:SetAction(lActionSlot);
			AutoActBar_SaveVar[lActionSlot] = { name = string.gsub(getglobal("AutoActBar_TooltipTextLeft1"):GetText(), "^.-%[(.*)%].*", "%1"), type = 1 };
			AAB_Tooltip:Hide();
		elseif ( lEquipped == 1 ) then
			AAB_Tooltip:SetOwner(UIParent, "ANCHOR_NONE");
			AAB_Tooltip:SetAction(lActionSlot);
			AutoActBar_SaveVar[lActionSlot] = { name = string.gsub(getglobal("AutoActBar_TooltipTextLeft1"):GetText(), "^.-%[(.*)%].*", "%1"), type = 2 };
			AAB_Tooltip:Hide();
		elseif ( lActionText ~= nil ) then
			AutoActBar_SaveVar[lActionSlot] = { name = lActionText, type = 3 };
		elseif ( lActionTexture ~= nil ) then
			if ( string.find(lActionTexture, "INV") ) then
				AAB_Tooltip:SetOwner(UIParent, "ANCHOR_NONE");
				AAB_Tooltip:SetAction(lActionSlot);
				AutoActBar_SaveVar[lActionSlot] = { name = string.gsub(getglobal("AutoActBar_TooltipTextLeft1"):GetText(), "^.-%[(.*)%].*", "%1"), type = 4 };
				AAB_Tooltip:Hide();
			end
		else
			AutoActBar_SaveVar[lActionSlot] = nil;
		end
	end
end

function AutoActBar_LoadBar()
	AutoActBar_Loading = true;
	for aslot, avalue in pairs(AutoActBar_SaveVar) do
		if ( aslot >= 25 and aslot <= 72) then
			local itemfind = false;
			if ( avalue.type == 1 ) then												-- type = 1    -   (,   .)
				for bag = 0, 4 do
					for bslot = 1, GetContainerNumSlots( bag ) do
						local bitem = GetContainerItemLink( bag, bslot );
						if ( bitem ) then
							if ( string.find( bitem, "%[" .. avalue.name .. "%]" ) ) then
--								DEFAULT_CHAT_FRAME:AddMessage("Slot " .. aslot .. " is Consumable: " .. avalue.name .. " in Bag" .. bag .. " (slot: " .. bslot .. ")");
								PickupContainerItem( bag, bslot );
								PlaceAction( aslot );
								ClearCursor();
								itemfind = true;
								break;
							end
						end
					end
					if itemfind then
						break;
--					else
--						DEFAULT_CHAT_FRAME:AddMessage("NOT FOUND Slot " .. aslot .. " is Consumable");
					end
				end
			elseif ( avalue.type == 2 ) then											-- type = 2    -    
				for islot = 0, 19 do
					local bitem = GetInventoryItemLink( "player", islot );
					if ( bitem ) then
						if (string.find( bitem, "%[" .. avalue.name .. "%]" ) ) then
--						DEFAULT_CHAT_FRAME:AddMessage("Slot " .. aslot .. " is Equipped: " .. avalue.name .. " in Slot " .. islot);
							PickupInventoryItem(islot);
							PlaceAction( aslot );
							ClearCursor();
							itemfind = true;
							break;
						end
					end
				end
			elseif ( avalue.type == 3 ) then											-- type = 3    - Macros
				local macroindex = GetMacroIndexByName( avalue.name );
				if ( macroindex ~= nil) then
					PickupMacro( macroindex );
					PlaceAction( aslot );
					ClearCursor();
--				DEFAULT_CHAT_FRAME:AddMessage("Slot " .. aslot .. " is Macros: " .. avalue.name .. " with Index: " .. macroindex);
				end
			elseif ( avalue.type == 4 ) then											-- type = 4    -   
				for bag = 0, 4 do
					for bslot = 1, GetContainerNumSlots( bag ) do
						local bitem = GetContainerItemLink( bag, bslot );
						if ( bitem ) then
							if (string.find( GetContainerItemLink( bag, bslot ), "%[" .. avalue.name .. "%]" ) ) then
--								DEFAULT_CHAT_FRAME:AddMessage("Slot " .. aslot .. " is Thing: " .. avalue.name .. " in Bag" .. bag .. " (slot: " .. bslot .. ")");
								PickupContainerItem( bag, bslot );
								PlaceAction( aslot );
								ClearCursor();
								itemfind = true;
								break;
							end
						end
					end
					if itemfind then
						break;
					end
				end
			end
		end
	end
	AutoActBar_Loading = false;
end

function AutoActBar_SlashCmd( msg )
	if ( string.lower( msg ) == "show" ) then
		local lActionSlot = 0;
		local lMessage = ""
--		for lActionSlot = 1, 120 do
		for lActionSlot = 25, 72 do
			if (lActionSlot >= 25 and lActionSlot <= 36) then
				lMessage = "Right ActionBar: "
			elseif (lActionSlot >= 37 and lActionSlot <= 48) then
				lMessage = "Right ActionBar 2: "
			elseif (lActionSlot >= 49 and lActionSlot <= 60) then
				lMessage = "Bottom Right ActionBar: "
			elseif (lActionSlot >= 61 and lActionSlot <= 72) then
				lMessage = "Bottom Left ActionBar: "
			else
				lMessage = ""
			end

			local lConsumable = IsConsumableAction(lActionSlot);            -- type = 1    -   (,   .)
			local lEquipped = IsEquippedAction(lActionSlot);                -- type = 2    -    
			local lActionText = GetActionText(lActionSlot);                 -- type = 3    - Macros
			local lActionTexture = GetActionTexture(lActionSlot);           -- type = 4    -   

			if ( lConsumable == 1 ) then
				AAB_Tooltip:SetOwner(UIParent, "ANCHOR_NONE");
				AAB_Tooltip:SetAction(lActionSlot);
				local justName = string.gsub(getglobal("AutoActBar_TooltipTextLeft1"):GetText(), "^.-%[(.*)%].*", "%1")
--				AutoActBar_SaveVar[lActionSlot] = { name = string.gsub(getglobal("AutoActBar_TooltipTextLeft1"):GetText(), "^.-%[(.*)%].*", "%1"), type = 1 };
				AAB_Tooltip:Hide();
				lMessage = lMessage .. "Slot " .. lActionSlot .. " is Consumable: [" .. justName .. "]";
			elseif ( lEquipped == 1 ) then
				AAB_Tooltip:SetOwner(UIParent, "ANCHOR_NONE");
				AAB_Tooltip:SetAction(lActionSlot);
				local justName = string.gsub(getglobal("AutoActBar_TooltipTextLeft1"):GetText(), "^.-%[(.*)%].*", "%1")
--				AutoActBar_SaveVar[lActionSlot] = { name = string.gsub(getglobal("AutoActBar_TooltipTextLeft1"):GetText(), "^.-%[(.*)%].*", "%1"), type = 2 };
				AAB_Tooltip:Hide();
				lMessage = lMessage .. "Slot " .. lActionSlot .. " is Equipped: [" .. justName .. "]";
			elseif ( lActionText ~= nil ) then
				AutoActBar_SaveVar[lActionSlot] = { name = lActionText, type = 3 };
				lMessage = lMessage .. "Slot " .. lActionSlot .. " is Macros: [" .. AutoActBar_SaveVar[lActionSlot].name .. "]";
			elseif ( lActionTexture ~= nil ) then
				if ( string.find(lActionTexture, "INV") ) then
					AAB_Tooltip:SetOwner(UIParent, "ANCHOR_NONE");
					AAB_Tooltip:SetAction(lActionSlot);
--					AutoActBar_SaveVar[lActionSlot] = { name = string.gsub(getglobal("AutoActBar_TooltipTextLeft1"):GetText(), "^.-%[(.*)%].*", "%1"), type = 4 };
					local justName = string.gsub(getglobal("AutoActBar_TooltipTextLeft1"):GetText(), "^.-%[(.*)%].*", "%1")
					AAB_Tooltip:Hide();
					lMessage = lMessage .. "Slot " .. lActionSlot .. " in Bag: [" .. justName .. "]";
				else
					AutoActBar_SaveVar[lActionSlot] = nil;
					lMessage = lMessage .. "Slot " .. lActionSlot .. " not empty.";
				end
			else
				AutoActBar_SaveVar[lActionSlot] = nil;
				lMessage = lMessage .. "Slot " .. lActionSlot;
			end
			DEFAULT_CHAT_FRAME:AddMessage(lMessage);
		end
	elseif ( string.lower( msg ) == "var" ) then
		for aslot, avalue in pairs(AutoActBar_SaveVar) do
			DEFAULT_CHAT_FRAME:AddMessage("Slot: " .. aslot .. ": " .. avalue.name );
		end
	elseif ( string.lower( msg ) == "save" ) then
		local lActionSlot = 0;
		AutoActBar_SaveVar = { name, type }
		for lActionSlot = 25, 72 do
			AutoActBar_SaveSlot( lActionSlot );
		end
	elseif ( string.lower( msg ) == "load" ) then
		AutoActBar_LoadBar()
	elseif ( string.lower( msg ) == "help" or msg == "?" ) then
		DEFAULT_CHAT_FRAME:AddMessage("help or ? - ");
		DEFAULT_CHAT_FRAME:AddMessage("save -    ");
		DEFAULT_CHAT_FRAME:AddMessage("load -    ");
		DEFAULT_CHAT_FRAME:AddMessage("var -   ");
	end
end

AAB_Tooltip = CreateFrame("GameTooltip", "AutoActBar_Tooltip", nil, "GameTooltipTemplate");

local eventFrame = CreateFrame("Frame");
eventFrame:Hide();
eventFrame:RegisterEvent("ADDON_LOADED");
--eventFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
eventFrame:RegisterEvent("PLAYER_ALIVE");
eventFrame:RegisterEvent("ACTIONBAR_SLOT_CHANGED");
eventFrame:SetScript("OnEvent",
	function(--[[self, event, arg1--]])
		if ( event == "ADDON_LOADED" ) then
			if ( arg1 == "AutoActBar" ) then
				AutoActBar_first = true;
				DEFAULT_CHAT_FRAME:AddMessage("AutoActBar 2.0 loaded.");
			end
--		elseif ( event == "PLAYER_ENTERING_WORLD" ) then
--			DEFAULT_CHAT_FRAME:AddMessage("Player entering world.");
--			for aslot, avalue in pairs(AutoActBar_SaveVar) do
--				DEFAULT_CHAT_FRAME:AddMessage("Slot: " .. aslot .. ": " .. avalue.name );
--			end
--			if ( not AutoActBar_first ) then
--				AutoActBar_LoadBar();
--			end
--			AutoActBar_first = false
		elseif ( event == "PLAYER_ALIVE" ) then
--			DEFAULT_CHAT_FRAME:AddMessage("Player alive.");
--			for aslot, avalue in pairs(AutoActBar_SaveVar) do
--				DEFAULT_CHAT_FRAME:AddMessage("Slot: " .. aslot .. ": " .. avalue.name );
--			end
			AutoActBar_LoadBar();
		elseif ( event == "ACTIONBAR_SLOT_CHANGED" and ( not AutoActBar_Loading ) ) then
--			DEFAULT_CHAT_FRAME:AddMessage("Slot: " .. arg1 .. " changed");
			AutoActBar_SaveSlot( arg1 );
		end
	end
);

SLASH_AUTOACTBAR1 = "/autobar";
SLASH_AUTOACTBAR2 = "/aab";

SlashCmdList["AUTOACTBAR"] = AutoActBar_SlashCmd;
